Unit qsf1e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS12_p;

procedure qsf1e(var INT1 :Extended; var INT2 :Extended; A :Extended;
                B :Extended; F :Func_F1E; RO :Extended; FI :Extended;
                E :Extended; var K :Integer; L1 :Integer; L2 :Integer;
                var IERR :Integer);

implementation

procedure qsf1e(var INT1 :Extended; var INT2 :Extended; A :Extended;
                B :Extended; F :Func_F1E; RO :Extended; FI :Extended;
                E :Extended; var K :Integer; L1 :Integer; L2 :Integer;
                var IERR :Integer);
var
C,BA :Integer;
I,L,M,N,Y,Z,BB,BD,P,T,U,V,W,R1,R2 :Extended;
Q :Array [0..10] of Extended;
BC :Array [0..6] of Extended;
const
TDS :Extended = 0.2666666666666667e0;
TSO :Extended = 0.7111111111111111e0;
TOF :Extended = 0.1555555555555556e0;
T33 :Extended = 0.33e0;
KMAX :Integer = 1048576;
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_13,_11,_12;
begin
IERR := 0;
K := Abs(K);
if ( K = 0 ) 
 then goto _12;
C := 0;
L := B-A;
_1:
I := A;
INT1 := 0.e0;
INT2 := 0.e0;
P := L/K;
Q[5] := F(I);
Y := P*0.5e0;
Z := P*0.25e0;
BB := RO*Y;
BC[3] := Sin(BB);
BC[4] := Cos(BB);
if ( BB-T33 ) < 0
 then goto _2
 else if ( BB-T33 ) > 0
       then goto _3
       else goto _2;
_2:
BD := BB*0.5e0;
BC[5] := Sin(BD);
BC[6] := Cos(BD);
Q[0] := TDS;
Q[1] := TSO*BC[6];
Q[2] := TOF*BC[4];
Q[3] := TSO*BC[5];
Q[4] := TOF*BC[3];
goto _4;
_3:
BC[0] := 1.e0/BB;
BC[1] := BC[0]*BC[0];
BC[2] := BC[1]*BC[1];
Q[0] := 4.e0*BC[1]*(BC[0]*(48.e0*BC[1]-19.e0)*BC[3]+3.e0*(1.e0-
    16.e0*BC[1])*BC[4]);
Q[1] := 32.e0*BC[1]*(BC[0]*(5.e0-12.e0*BC[1])*BC[3]-(1.e0-12.e0*
    BC[1])*BC[4])/3.e0;
Q[2] := BC[0]*((3.e0-46.e0*BC[1]+96.e0*BC[2])*BC[3]+2.e0*BC[0]*
    (7.e0-48.e0*BC[1])*BC[4])/3.e0;
Q[3] := -16.e0*BC[1]*((1.e0-3.e0*BC[1])*BC[3]+3.e0*BC[0]*BC[4])/
    3.e0;
Q[4] := BC[0]*(BC[0]*(11.e0-24.e0*BC[1])*BC[3]-3.e0*(1.e0-8.e0*
    BC[1])*BC[4])/3.e0;
_4:
for BA:=1 to K do
 begin
  U := FI+RO*(I+Y);
  Q[9] := Sin(U);
  Q[10] := Cos(U);
  if ( BA-K ) < 0
   then goto _6
   else if ( BA-K ) > 0
         then goto _6
         else goto _5;
_5:
  T := B;
  goto _7;
_6:
  T := I+P;
_7:
  Q[6] := F(T);
  Q[8] := F(I+Z);
  Q[7] := F(I+P*0.75e0);
  V := Q[0]*F(I+Y)+Q[1]*(Q[8]+Q[7])+Q[2]*(Q[5]+Q[6]);
  W := Q[3]*(Q[7]-Q[8])+Q[4]*(Q[6]-Q[5]);
  INT1 := INT1+(Q[9]*V+Q[10]*W);
  INT2 := INT2+(Q[10]*V-Q[9]*W);
  Q[5] := Q[6];
  T := I+P;
  I := T;
_8:
 end;
INT1 := INT1*Y;
INT2 := INT2*Y;
if ( E = 0.0e0 ) 
 then goto _13;
_9:
C := C+1;
if ( C-1 ) < 0
 then goto _11
 else if ( C-1 ) > 0
       then goto _11
       else goto _10;
_10:
M := INT1;
N := INT2;
K := 2*K;
if ( K < KMAX ) 
 then goto _1;
_13:
IERR := 65;
K := KMAX;
UTQS12(IERR,7);
goto _12;
_11:
R1 := Abs(INT1-M)*L1;
R2 := Abs(INT2-N)*L2;
if ( EMax1(R1,R2) <= Abs(E) ) 
 then goto _12;
if ( R1 <= L1*SYS051*Abs(INT1) ) and ( 
     R2 <= L2*SYS051*Abs(INT2) ) 
 then goto _13;
goto _10;
_12:
end;

end.
